#%% No access to hidden (__<member>) members
class Robot():
    def __init__(self, name, ip):
        self.name = name
        self.__ip = ip

    def print_robot(self):
      print("Created new robot {} with ip {}!".format(self.name, self.__ip) )

 
robot_1 = Robot("Bob", "192.023.031.223")
robot_1.print_robot()

#%% Acces to hidden member via getter and setter
class Robot():
 
    def __init__(self, name, ip):
        self.name = name
        self.__ip = ip
    # Getter
    def get_ip(self):
      return self.__ip
    # Setter
    def set_ip(self, new_ip):
      self.__ip = new_ip
      print("IP changed!") 

robot_1 = Robot("Bob", "192.023.31.224")
robot_1.set_ip("192.1.1.1")

#%% Printing Robot object, which casts to str, gives the memory adr.

class Robot():
 
    def __init__(self, name, ip):
        self.name = name
        self.__ip = ip
    # Getter
    def get_ip(self):
      return self.__ip
    # Setter
    def set_ip(self, new_ip):
      self.__ip = new_ip
      print("IP changed!") 

robot_1 = Robot("Bob", "192.023.31.224")

print(robot_1)

#%% Overloading of Dunder method __str__() to print object

class Robot():
 
    def __init__(self, name, ip):
        self.name = name
        self.__ip = ip
    # Getter
    def get_ip(self):
      return self.__ip
    # Setter
    def set_ip(self, new_ip):
      self.__ip = new_ip
      print("IP changed!") 

    def __str__(self):
        return F"I am {self.name} the robot!"

robot_1 = Robot("Bob", "192.023.31.224")

print(robot_1)
# %%
